## xa 2.2.0

=== Makefile ===

# Unix gcc or DOS go32 cross-compiling gcc
#
CC=gcc
LD=gcc
CFLAGS=-W -Wall -pedantic -ansi -g
# CC=gcc-go32
# LD=gcc-go32
# CFLAGS=-W -Wall -pedantic 

# Other cc
#CC=cc
#CFLAGS=
#LD=ld

INSTALLDIR=/usr/local

all: xa uncpk

xa:
	(cd src; LD=${LD} CC="${CC} ${CFLAGS}" ${MAKE}; )

load:	
	(cd loader; CC="${CC} ${CFLAGS}" ${MAKE}; )

uncpk:
	(cd misc; CC="${CC} ${CFLAGS}" ${MAKE}; )

dos: clean
	(cd src; LD=gcc-go32 CC="gcc-go32 -W -Wall -pedantic" ${MAKE}; )
	(cd misc; CC="gcc-go32 -W -Wall -pedantic" ${MAKE}; )
	rm -f xa file65 ld65 uncpk printcbm reloc65 mkrom.sh src/*.o

clean:
	(cd src; ${MAKE} clean )
	(cd loader; ${MAKE} clean )
	(cd misc; ${MAKE} mrproper )
	rm -f xa *.exe

install: xa uncpk
	for i in xa reloc65 ld65 file65 printcbm uncpk; 	\
	  do cp $$i ${INSTALLDIR}/bin; 				\
	done

=== misc/Makefile ===

XCBMLIB = ..

CFLAGS = 

LIBS = -lncurses -ltermcap -lm


all: ../uncpk ../printcbm ../file65 ../mkrom.sh ../reloc65 ../ld65

../uncpk: uncpk.c
	${CC} ${CFLAGS} uncpk.c -o $(XCBMLIB)/uncpk

../printcbm: printcbm.c
	${CC} ${CFLAGS} printcbm.c -o $(XCBMLIB)/printcbm

../file65: file65.c
	${CC} ${CFLAGS} file65.c -o $(XCBMLIB)/file65

../ld65: ld65.c
	${CC} ${CFLAGS} ld65.c -o $(XCBMLIB)/ld65

../reloc65: reloc65.c
	${CC} ${CFLAGS} reloc65.c -o $(XCBMLIB)/reloc65

../mkrom.sh: mkrom.sh
	cp mkrom.sh ../mkrom.sh

lt1: lt1.a
	../xa -R -c -o lt1 lt1.a

lt2: lt2.a
	../xa -R -c -o lt2 lt2.a

lt: lt1 lt2
	../ld65 -o lt lt1 lt2 

clean:
	rm -f *.o 

mrproper: clean
	rm -f ../uncpk ../printcbm ../file65 ../mkrom.sh ../reloc65 ../ld65
	rm -f lt1 lt2 lt

=== src/Makefile ===

OBJ = xa.o xaa.o xal.o xap.o xat.o xar.o xar2.o xao.o xau.o xam.o

# CFLAGS=-W -Wall -pedantic -ansi  #-g

LD=${CC}

all: xa

xa: ${OBJ}
	${LD}  -o ../xa ${OBJ} -lc

clean: 
	rm -f *.o

mrproper: clean
	rm -f ../xa

## xa 2.3.0

=== Makefile ===
# Unix gcc or DOS go32 cross-compiling gcc
#
CC = gcc
LD = gcc
CFLAGS = -O2 -W -Wall -pedantic -ansi
# CC = gcc-go32
# LD = gcc-go32
# CFLAGS = -W -Wall -pedantic 

# Other cc
#CC = cc
#CFLAGS =
#LD = ld

DESTDIR = /usr/local

BINDIR = $(DESTDIR)/bin
MANDIR = $(DESTDIR)/share/man/man1
DOCDIR = $(DESTDIR)/share/doc

MKDIR = mkdir -p
INSTALL = install

all: xa uncpk

xa:
	(cd src && LD=${LD} CC="${CC} ${CFLAGS}" ${MAKE})

load:	
	(cd loader && CC="${CC} ${CFLAGS}" ${MAKE})

uncpk:
	(cd misc && CC="${CC} ${CFLAGS}" ${MAKE})

dos: clean
	(cd src && LD=gcc-go32 CC="gcc-go32 -W -Wall -pedantic" ${MAKE})
	(cd misc && CC="gcc-go32 -W -Wall -pedantic" ${MAKE})
	rm -f xa file65 ldo65 uncpk printcbm reloc65 mkrom.sh src/*.o

clean:
	(cd src && ${MAKE} clean)
	(cd loader && ${MAKE} clean)
	(cd misc && ${MAKE} mrproper)
	rm -f xa *.exe

install: xa uncpk
	$(MKDIR) $(BINDIR)
	$(MKDIR) $(MANDIR)
	$(INSTALL) xa reloc65 ldo65 file65 printcbm uncpk $(BINDIR)
	$(INSTALL) man/file65.1 man/ldo65.1 man/printcbm.1 man/reloc65.1 man/uncpk.1 man/xa.1 $(MANDIR)
	#$(MKDIR) $(DOCDIR)/xa65

dist: clean
	cd .. ; tar cvf xa-2.3.0.tar xa-2.3.0 ; gzip xa-2.3.0.tar

=== src/Makefile ===
OBJ = xa.o xaa.o xal.o xap.o xat.o xar.o xar2.o xao.o xau.o xam.o

#CFLAGS=-W -Wall -pedantic -ansi  #-g
CFLAGS=-W -Wall -ansi -O2

LD = ${CC}

all: xa

xa: ${OBJ}
	${LD} -o ../xa ${OBJ} -lc

clean: 
	rm -f *.o

mrproper: clean
	rm -f ../xa

## xa 2.3.3

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,9 @@
 CC = gcc
 LD = gcc
 CFLAGS = -O2 -W -Wall -pedantic -ansi
+LDFLAGS = -lc
+
+# for DOS?
 # CC = gcc-go32
 # LD = gcc-go32
 # CFLAGS = -W -Wall -pedantic 
@@ -33,15 +36,19 @@
 	(cd misc && CC="${CC} ${CFLAGS}" ${MAKE})
 
 dos: clean
-	(cd src && LD=gcc-go32 CC="gcc-go32 -W -Wall -pedantic" ${MAKE})
-	(cd misc && CC="gcc-go32 -W -Wall -pedantic" ${MAKE})
+	(cd src && LD=gcc-go32 CC=gcc-go32 CFLAGS="-W -Wall -pedantic" ${MAKE})
+	(cd misc && CC=gcc-go32 CFLAGS="-W -Wall -pedantic" ${MAKE})
 	rm -f xa file65 ldo65 uncpk printcbm reloc65 mkrom.sh src/*.o
 
+mingw: clean
+	(cd src && LD=${LD} CC=${CC} CFLAGS="${CFLAGS}" LDFLAGS="" ${MAKE})
+	(cd misc && LD=${LD} CC=${CC} CFLAGS="${CFLAGS}" LDFLAGS="" ${MAKE})
+	
 clean:
 	(cd src && ${MAKE} clean)
 	(cd loader && ${MAKE} clean)
 	(cd misc && ${MAKE} mrproper)
-	rm -f xa *.exe
+	rm -f xa *.exe *.o65
 
 install: xa uncpk
 	$(MKDIR) $(BINDIR)
@@ -51,4 +58,4 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	cd .. ; tar cvf xa-2.3.0.tar xa-2.3.0 ; gzip xa-2.3.0.tar
+	cd .. ; tar cvf xa-2.3.3.tar xa-2.3.3 ; gzip xa-2.3.3.tar

## xa 2.3.5

=== Makefile ===
--- 
+++ 
@@ -58,4 +58,5 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	cd .. ; tar cvf xa-2.3.3.tar xa-2.3.3 ; gzip xa-2.3.3.tar
+	#cd .. ; tar cvf xa-2.3.5A.tar xa-2.3.5 ; gzip xa-2.3.5A.tar
+	cd .. ; tar cvf xa-2.3.5.tar xa-2.3.5 ; gzip xa-2.3.5.tar

=== misc/Makefile ===

XCBMLIB = ..

CFLAGS =  -Wall -O2 -ansi -W

LIBS = #-lncurses -ltermcap -lm


all: ../mkrom.sh ../uncpk ../printcbm ../file65 ../reloc65 ../ldo65

../uncpk: uncpk.c
	${CC} ${CFLAGS} uncpk.c -o $(XCBMLIB)/uncpk

../printcbm: printcbm.c
	${CC} ${CFLAGS} printcbm.c -o $(XCBMLIB)/printcbm

../file65: file65.c
	${CC} ${CFLAGS} file65.c -o $(XCBMLIB)/file65

../ldo65: ldo65.c
	${CC} ${CFLAGS} ldo65.c -o $(XCBMLIB)/ldo65

../reloc65: reloc65.c
	${CC} ${CFLAGS} reloc65.c -o $(XCBMLIB)/reloc65

../mkrom.sh: mkrom.sh
	cp mkrom.sh ../mkrom.sh

lt1: lt1.a
	../xa -R -c -o lt1 lt1.a

lt2: lt2.a
	../xa -R -c -o lt2 lt2.a

lt: lt1 lt2
	../ldo65 -o lt lt1 lt2 

clean:
	rm -f *.o 

mrproper: clean
	rm -f ../uncpk ../printcbm ../file65 ../mkrom.sh ../reloc65 ../ldo65
	rm -f lt1 lt2 lt

=== tests/cpp/Makefile ===
default:
	cc -E over.c > over.asm
	../../xa over.asm

=== tests/ldoreloc/Makefile ===

all: t

1.o65: 1.s
	xa -R -c -o 1.o65 1.s
	hexdump -C 1.o65 > 1.o65.hex

2.o65: 2.s
	xa -R -c -o 2.o65 2.s
	hexdump -C 2.o65 > 2.o65.hex

linked.o65: 1.o65 2.o65
	ldo65 -o linked.o65 1.o65 2.o65
	hexdump -C linked.o65 > linked.o65.hex

t: linked.o65
	reloc65 -bt 32768 -xt -o t linked.o65
	hexdump -C t > t.hex
	diff t t.ok

clean:
	rm -f *.o65 *.hex t

=== tests/relocundef/Makefile ===

all: a.o65 b.o65

a.o65: test1.o65
	echo "********* This should give a warning about an undefined relocation table entry"
	reloc65 -X test1.o65
	hexdump -C a.o65 > a.o65.hex

b.o65: test2.o65
	echo "********* This should NOT give a warning"
	reloc65 -X -o b.o65 test2.o65
	hexdump -C b.o65 > b.o65.hex

test1.o65: test1.a65
	xa -R -Lundefl -Ll2 -o test1.o65 test1.a65
	hexdump -C test1.o65 > test1.o65.hex

test2.o65: test2.a65
	xa -R -o test2.o65 test2.a65
	hexdump -C test2.o65 > test2.o65.hex

clean:
	rm -f test1.o65 a.o65 test1.o65.hex a.o65.hex 
	rm -f test2.o65 b.o65 test2.o65.hex b.o65.hex

## xa 2.3.8

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,9 @@
 #
 CC = gcc
 LD = gcc
-CFLAGS = -O2 -W -Wall -pedantic -ansi
+# for testing. not to be used; build failures in misc/.
+#CFLAGS = -O2 -W -Wall -pedantic -ansi
+CFLAGS = -O2
 LDFLAGS = -lc
 
 # for DOS?
@@ -24,7 +26,10 @@
 MKDIR = mkdir -p
 INSTALL = install
 
-all: xa uncpk
+all: killxa xa uncpk
+
+killxa:
+	rm -f xa
 
 xa:
 	(cd src && LD=${LD} CC="${CC} ${CFLAGS}" ${MAKE})
@@ -58,5 +63,8 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	#cd .. ; tar cvf xa-2.3.5A.tar xa-2.3.5 ; gzip xa-2.3.5A.tar
-	cd .. ; tar cvf xa-2.3.5.tar xa-2.3.5 ; gzip xa-2.3.5.tar
+	#cd .. ; tar cvf xa-2.3.8A.tar xa-2.3.8 ; gzip xa-2.3.8A.tar
+	cd .. ; tar cvf xa-2.3.8.tar xa-2.3.8 ; gzip xa-2.3.8.tar
+
+test: xa uncpk
+	cd tests && ./harness -make="$(MAKE)" -cc="$(CC)" -cflags="$(CFLAGS)"

=== tests/incerr/Makefile ===
default:
	# in 6502 mode, it will fail.
	../../xa test.s || exit 0 && exit 1
	# in 65816 mode, it will pass.
	../../xa -w test.s

clean:
	rm -f a.o65

## xa 2.3.11

=== Makefile ===
--- 
+++ 
@@ -63,8 +63,7 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	#cd .. ; tar cvf xa-2.3.8A.tar xa-2.3.8 ; gzip xa-2.3.8A.tar
-	cd .. ; tar cvf xa-2.3.8.tar xa-2.3.8 ; gzip xa-2.3.8.tar
+	cd .. ; tar cvf xa-2.3.11.tar xa-2.3.11 ; gzip xa-2.3.11.tar
 
 test: xa uncpk
 	cd tests && ./harness -make="$(MAKE)" -cc="$(CC)" -cflags="$(CFLAGS)"

=== src/Makefile ===
OBJ = xa.o xaa.o xal.o xap.o xat.o xar.o xar2.o xao.o xau.o xam.o xacharset.o

#CFLAGS=-W -Wall -pedantic -ansi  #-g
#CFLAGS=-W -Wall -ansi -O2
#LD = ${CC}
#LDFLAGS = "-lc"

all: xa

xa: ${OBJ}
	${LD} -o ../xa ${OBJ} ${LDFLAGS}

clean: 
	rm -f *.o *.o65

mrproper: clean
	rm -f ../xa

=== tests/cpktest/Makefile ===
default:
	../../xa -l test.l -o test.o pack_eng.a65
	cmp test.l english.l || exit 1
	../hextool -cmp=eng.ok < test.o

	../../xa -l test.l -o test.o pack_ger.a65
	cmp test.l deutsch.l || exit 1
	../hextool -cmp=de.ok < test.o
clean:
	rm -f *.o test.l

=== tests/csapiec/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa -DBUG=1 -o test.o test.s || exit 0 && exit 1
	../../xa -R -DBUG=1 -o testseg.o test.s || exit 0 && exit 1
	# xa *should* allow this to happen.
	../../xa -o test.o test.s
	../hextool -cmp=test.ok < test.o
	../../xa -R -o testseg.o test.s
	../hextool -cmp=testseg.ok < testseg.o

clean:
	rm -f *.o

=== tests/neg_offset/Makefile ===
default: test0 test1 test2 test3 test4 test5 test6 test7 test8 

test0:
	# this test must fail.
	../../xa -o test0.o test0.s || exit 0 && exit 1

test1:
	../../xa -R -LLIB6502 test1.s -o test1.o
	../hextool -cmp=ok1 < test1.o

test2:
	../../xa -R -LLIB6502 test2.s -o test2.o
	../hextool -cmp=ok2 < test2.o

test3:
	../../xa -R -LLIB6502 test3.s -o test3.o
	../hextool -cmp=ok3 < test3.o

test4:
	../../xa -R -LLIB6502 test4.s -o test4.o
	../hextool -cmp=ok4 < test4.o

test5:
	../../xa -R -LLIB6502 test5.s -o test5.o
	../hextool -cmp=ok5 < test5.o

test6:
	# this test must fail.
	../../xa -R -LLIB6502 test6.s -o test6.o || exit 0 && exit 1

test7:
	# this test must fail.
	../../xa -R -LLIB6502 test7.s -o test7.o || exit 0 && exit 1

test8:
	# this test must fail.
	../../xa -R -LLIB6502 test8.s -o test8.o || exit 0 && exit 1

clean:
	rm -f *.o

## xa 2.3.12

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	cd .. ; tar cvf xa-2.3.11.tar xa-2.3.11 ; gzip xa-2.3.11.tar
+	cd .. ; tar cvf xa-2.3.12.tar xa-2.3.12 ; gzip xa-2.3.12.tar
 
 test: xa uncpk
 	cd tests && ./harness -make="$(MAKE)" -cc="$(CC)" -cflags="$(CFLAGS)"

=== tests/charset/Makefile ===
default:
	../../xa test.s
	../hextool -cmp=no-charset.o < a.o65
	../../xa -O PETSCII test.s
	../hextool -cmp=petscii.o < a.o65
	../../xa -O PETSCREEN test.s
	../hextool -cmp=petscreen.o < a.o65
	../../xa -O HIGH test.s
	../hextool -cmp=high.o < a.o65

clean:
	rm -rf a.o65

=== tests/ldoreloc/Makefile ===

default: all
all: t

1.o65: 1.s
	../../xa -R -c -o 1.o65 1.s
	../hextool 1.o65 > 1.o65.hex

2.o65: 2.s
	../../xa -R -c -o 2.o65 2.s
	../hextool 2.o65 > 2.o65.hex

linked.o65: 1.o65 2.o65
	../../ldo65 -o linked.o65 1.o65 2.o65
	../hextool linked.o65 > linked.o65.hex

t: linked.o65
	../../reloc65 -bt 32768 -xt -o t linked.o65
	../hextool t > t.hex
	../hextool -cmp=t < t.ok

clean:
	rm -f *.o65 *.hex t

=== tests/openpp/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa test.inc || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa -DBUG test.s -o test.o
	../hextool -cmp=ok < test.o
	../../xa test.s -o test.o
	../hextool -cmp=ok < test.o

clean:
	rm -f *.o

=== tests/relocundef/Makefile ===

default: all
all: a.o65 b.o65 compare

a.o65: test1.o65
	@echo "********* This should give a warning about an undefined relocation table entry"
	../../reloc65 -X test1.o65
	../hextool a.o65 > a.o65.hex

b.o65: test2.o65
	@echo "********* This should NOT give a warning"
	../../reloc65 -X -o b.o65 test2.o65
	../hextool b.o65 > b.o65.hex

test1.o65: test1.a65
	../../xa -R -Lundefl -Ll2 -o test1.o65 test1.a65
	../hextool test1.o65 > test1.o65.hex

test2.o65: test2.a65
	../../xa -R -o test2.o65 test2.a65
	../hextool test2.o65 > test2.o65.hex

compare:
	../hextool -cmp=a.ok < a.o65
	../hextool -cmp=b.ok < b.o65

clean:
	rm -f test1.o65 a.o65 test1.o65.hex a.o65.hex 
	rm -f test2.o65 b.o65 test2.o65.hex b.o65.hex

=== debian/changelog ===
xa (2.3.12-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
  * Enable the test suite. Closes: #966181.
  * Fix a number of segfaults. Closes: #715904, #716289, #716483.

 -- Stephen Kitt <skitt@debian.org>  Fri, 18 Feb 2022 21:15:45 +0100

xa (2.3.11-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release, which builds with GCC 10 (Closes: #957966).
  * Override the build flags (the 2.3.11 build sets them unconditionnally,
    unlike the 2.3.8 build).
  * Set the linker so that the package can be cross-built; thanks to
    Helmut Grohne for the patch (Closes: #948176).

 -- Stephen Kitt <skitt@debian.org>  Fri, 24 Jul 2020 12:46:11 +0200

xa (2.3.8-2) unstable; urgency=low

  * debian/control:
    - Bump Standards-Version to 4.1.1
  * New upload signed with correct key

 -- David Weinehall <tao@debian.org>  Tue, 31 Oct 2017 22:37:07 +0200

xa (2.3.8-1) unstable; urgency=low

  * New upstream release
  * Switch to debhelper 10
  * debian/control:
    - Bump Standards-Version to 4.1.0
    - Build-Depends: debhelper (>= 10)
  * debian/copyright:
    - Modified to be machine readable
  * debian/rules:
    - Override dh_auto_test; the test suite causes the package to FTBFS

 -- David Weinehall <tao@debian.org>  Sat, 16 Sep 2017 00:05:46 +0400

xa (2.3.7-1) experimental; urgency=low

  * New upstream release (Closes: #773717)
    | Thanks Andreas Hausmann
  * Makefile: modified to handle CFLAGS/CPPFLAGS/LDFLAGS properly
    | This is needed to enable hardening
  * Switch to debhelper 9
  * debian/compat:
    - Use compat level 9 to enable hardening
  * Added debian/source/format (1.0)
  * Added debian/watch
  * Added debian/doc-base
  * debian/control:
    - Bump Standards-Version to 3.9.6
    - Build-Depends: debhelper (>= 9)
    - Depends: ${misc:depends}
  * debian/rules:
    - Minimised, thanks to new version of debhelper

 -- David Weinehall <tao@debian.org>  Wed, 07 Jan 2015 00:06:39 +0200

xa (2.3.5-1) unstable; urgency=low

  * New upstream release
  * Added link to upstream web site
  * Bump Standards-Version to 3.8.2

 -- David Weinehall <tao@debian.org>  Sun, 12 Jul 2009 22:56:19 +0300

xa (2.3.3-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.7.3 (No changes needed)
  * debian/copyright: Converted to UTF-8
  * debian/rules: Don't ignore errors from make clean

 -- David Weinehall <tao@debian.org>  Tue, 01 Apr 2008 02:04:25 +0300

xa (2.3.0-2) unstable; urgency=low

  * Update upstream maintainer's email address
  * Bump Standards-Version to 3.7.2.2 (No changes needed)

 -- David Weinehall <tao@debian.org>  Thu, 26 Oct 2006 00:02:17 +0300

xa (2.3.0-1) unstable; urgency=low

  * New upstream version
    - Forcing of absoluting addressing now works (Closes: #208969)

 -- David Weinehall <tao@debian.org>  Wed, 12 Apr 2006 17:14:24 +0300

xa (2.2.0-p1-1) unstable; urgency=low

  * Initial Release (Closes: #160023)

 -- David Weinehall <tao@debian.org>  Sun, 27 Jul 2003 22:00:28 +0200

=== debian/control ===
Source: xa
Section: devel
Priority: optional
Maintainer: David Weinehall <tao@debian.org>
Build-Depends: debhelper (>= 10)
Standards-Version: 4.1.1
Homepage: http://www.floodgap.com/retrotech/xa/

Package: xa65
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: cross-assembler and utility suite for 65xx/65816 processors
 xa65 is a cross-assembler and utility suite for the 65xx series of
 8-bit processors, and the 65816, a 16-bit version of the processor.
 The 6502 was used in computers such as the Commodore 64, Apple II,
 and many more.

=== debian/watch ===
# watch control file for uscan
version=2
http://www.floodgap.com/retrotech/xa/dists/xa-(.*)\.tar\.gz	debian	uupdate

## xa 2.3.13

=== debian/changelog ===
xa (2.3.13-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release, merging file65-a-segfault.patch,
    reloc65-argument-segfault.patch, xa-argument-segfaults.patch.
  * Switch to debhelper compatibility level 13.
  * Bump debian/watch to version 4.
  * Use secure URLs for upstream.
  * Set “Rules-Requires-Root: no”.

 -- Stephen Kitt <skitt@debian.org>  Sun, 13 Nov 2022 15:18:31 +0100

## xa 2.3.14

=== tests/branch/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa bor.s || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa -w bir.s -o test.o
	../hextool -cmp=bir.ok < test.o

clean:
	rm -f *.o

=== tests/chppch/Makefile ===
default:
	../../xa -p'~' -e test.out test.c
	../hextool -cmp=ok.out < test.out

clean:
	rm -f a.o65 test.out

=== tests/dos51/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa -DBUG test.s || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa test.s -o test.o
	../hextool -cmp=ok < test.o

clean:
	rm -f *.o

=== tests/reset_segment/Makefile ===
default: test1 

test1:
	../../xa -R -LLIB6502 test1.s -o test1.o
	../hextool -cmp=ok1 < test1.o
	../../xa -R test2.s -o test2.o
	../hextool -cmp=ok2 < test2.o

clean:
	rm -f *.o

=== debian/changelog ===
xa (2.3.14-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 12 Feb 2023 15:07:15 +0100

## xa 2.4.0

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,12 @@
 # Unix gcc or DOS go32 cross-compiling gcc
 #
+VERS = 2.4.0
 CC = gcc
 LD = gcc
 # for testing. not to be used; build failures in misc/.
 #CFLAGS = -O2 -W -Wall -pedantic -ansi
-CFLAGS = -O2
+#CFLAGS = -O2 -g
+CFLAGS = -O2 
 LDFLAGS = -lc
 
 # for DOS?
@@ -26,6 +28,8 @@
 MKDIR = mkdir -p
 INSTALL = install
 
+TESTS=ALL
+
 all: killxa xa uncpk
 
 killxa:
@@ -34,8 +38,8 @@
 xa:
 	(cd src && LD=${LD} CC="${CC} ${CFLAGS}" ${MAKE})
 
-load:	
-	(cd loader && CC="${CC} ${CFLAGS}" ${MAKE})
+#load:	
+#	(cd loader && CC="${CC} ${CFLAGS}" ${MAKE})
 
 uncpk:
 	(cd misc && CC="${CC} ${CFLAGS}" ${MAKE})
@@ -51,11 +55,11 @@
 	
 clean:
 	(cd src && ${MAKE} clean)
-	(cd loader && ${MAKE} clean)
+	#(cd loader && ${MAKE} clean)
 	(cd misc && ${MAKE} mrproper)
-	rm -f xa *.exe *.o65
+	rm -f xa *.exe *.o65 *.s core
 
-install: xa uncpk
+install: all
 	$(MKDIR) $(BINDIR)
 	$(MKDIR) $(MANDIR)
 	$(INSTALL) xa reloc65 ldo65 file65 printcbm uncpk $(BINDIR)
@@ -63,7 +67,14 @@
 	#$(MKDIR) $(DOCDIR)/xa65
 
 dist: clean
-	cd .. ; tar cvf xa-2.3.12.tar xa-2.3.12 ; gzip xa-2.3.12.tar
+	cd .. ; tar cvf xa-$(VERS).tar xa-$(VERS) ; gzip xa-$(VERS).tar
 
-test: xa uncpk
-	cd tests && ./harness -make="$(MAKE)" -cc="$(CC)" -cflags="$(CFLAGS)"
+# no prereqs to force parallel make to play nice
+test: 
+	rm -rf xa
+	$(MAKE) xa
+	$(MAKE) uncpk
+	cd tests && ./harness \
+		-tests="$(TESTS)" \
+		-cc="$(CC)" -cflags="$(CFLAGS)"  \
+		-make="$(MAKE)" -makeflags="$(MAKEFLAGS)"

=== src/Makefile ===
OBJ = xa.o xaa.o xal.o xap.o xat.o xar.o xar2.o xao.o xau.o xam.o xacharset.o xalisting.o

#CFLAGS=-W -Wall -pedantic -ansi -g
#CFLAGS=-W -Wall -ansi -O2
#CFLAGS=-g -std=c11 -D_GNU_SOURCE
#LD = ${CC}
#LDFLAGS = "-lc"

all: xa

xa: ${OBJ}
	${LD} -o ../xa ${OBJ} ${LDFLAGS}

clean: 
	rm -f *.o *.o65

mrproper: clean
	rm -f ../xa

=== attic/loader/Makefile ===

all: loader example test2 rom65

loader: loader.a65 file.def
	../xa loader.a65 -o loader

clean:
	rm -f loader test2 example a.o65 rom65

example: test.a
	../xa -R test.a -o example

test2: test2.a
	../xa test2.a -o test2

rom65: test.a
	../mkrom.sh -O "-G" -S "-bd 1234" -R rom65 test.a test.a

=== tests/alxl/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa alxl.s || exit 0 && exit 1
	../../xa alxlo1.s || exit 0 && exit 1
	../../xa alxlo2.s || exit 0 && exit 1
	../../xa alxlx1.s || exit 0 && exit 1
	../../xa alxlx2.s || exit 0 && exit 1
	../../xa alxlx3.s || exit 0 && exit 1
	../../xa sizes.s || exit 0 && exit 1
	../../xa -w alxlx1.s || exit 0 && exit 1
	../../xa -w alxlx2.s || exit 0 && exit 1
	../../xa -w alxlx3.s || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa -w alxl.s -o alxl.o
	../hextool -cmp=alxl.ok < alxl.o
	../../xa -w alxlo1.s -o alxlo1.o
	../hextool -cmp=alxlo1.ok < alxlo1.o
	../../xa -w alxlo2.s -o alxlo2.o
	../hextool -cmp=alxlo2.ok < alxlo2.o
	../../xa -w sizes.s -o sizes.o
	../hextool -cmp=sizes.ok < sizes.o

clean:
	rm -f *.o

=== tests/binclude/Makefile ===
default:
	../../xa test.asm -o test.o
	../hextool -cmp=test.ok < test.o
	../../xa -w test.asm -o test816.o
	../hextool -cmp=test.ok < test816.o
	../../xa test2.asm -o test2.o
	../hextool -cmp=test2.ok < test2.o
	../../xa test3.asm -o test3.o
	../hextool -cmp=test.ok < test3.o

clean:
	rm -f *.o

=== tests/ca65/Makefile ===
#
# Makefile for tests
#

XA=../../xa

CA65=ca65
LD65=ld65
OBJS=unnamed1 unnamed2 escape2

# escape1 test only relevant if xa23 mode is on
#tests: unnamed1 unnamed2 escape1 escape2 clean
tests: $(OBJS)

# BSD make won't populate $< in these and GNU make doesn't like $>

unnamed1: unnamed1.a65
	#${CA65} unnamed1.a65; ${LD65} -t none -o unnamed1.ca65 unnamed1.o; rm unnamed1.o
	${XA} -XCA65 unnamed1.a65 -o $@
	../hextool -cmp=unnamed1.ca65 < $@

unnamed2: unnamed2.a65
	#${CA65} unnamed2.a65; ${LD65} -t none -o unnamed2.ca65 unnamed2.o; rm unnamed2.o
	${XA} -XCA65 unnamed2.a65 -o $@ 2>a.err || true
	../hextool -cmp=unnamed2.ca65 < $@

# add -XXA23 to actually test this
escape1: escape1.a65
	${XA} escape1.a65 -o $@
	../hextool -cmp=escape1.out < $@

escape2: escape2.a65
	#${CA65} escape2.a65; ${LD65} -t none -o escape2.ca65 escape2.o; rm escape2.o
	${XA} -XCA65 escape2.a65 -o $@ 2>a.err || true
	../hextool -cmp=escape2.ca65 < $@

clean:
	rm -f *.err a.o65 $(OBJS)

=== tests/comcom/Makefile ===
default:
	# this should fail.
	../../xa scomcom.asm || exit 0 && exit 1
	# it did fail. these should now all succeed.
	../../xa -M scomcom.asm
	../hextool -cmp=scomcomm.ok < a.o65
	../../xa comcom.asm
	../hextool -cmp=comcom.ok < a.o65
	../../xa -M comcom.asm
	../hextool -cmp=comcomm.ok < a.o65

clean:
	rm -f a.o65

=== tests/cpp/Makefile ===
default:
	$(CC) -E over.c > over.asm
	../../xa -w over.asm
	../hextool -cmp=expected.o < a.o65

clean:
	rm -f over.asm a.o65

=== tests/fordef/Makefile ===
default:
	# this must not pass.
	../../xa -DFAIL test3.asm || exit 0 && exit 1
	# these must pass.
	../../xa test3.asm
	../hextool -cmp=test3.ok < a.o65
	# testing warnings.
	../../xa -e test.out test.asm
	../hextool -cmp=ok.out < test.out
	../hextool -cmp=test1.ok < a.o65

clean:
	rm -f a.o65 test.out

=== tests/math/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa -o divzero.o divzero.s || exit 0 && exit 1
	../../xa -o divzero2.o divzero2.s || exit 0 && exit 1

clean:
	rm -f *.o

=== tests/relocmode/Makefile ===
default: test1 

test1:
	# this should fail in non-relocating mode
	../../xa  test1.s -o test1.o || exit 0 && exit 1
	../../xa  -R test1.s -o test1.o 
	../hextool -cmp=ok < test1.o

clean:
	rm -f *.o

=== tests/relocundef/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 	../../xa -R -o test2.o65 test2.a65
 	../hextool test2.o65 > test2.o65.hex
 
-compare:
+compare: a.o65 b.o65
 	../hextool -cmp=a.ok < a.o65
 	../hextool -cmp=b.ok < b.o65

=== debian/changelog ===
xa (2.4.0-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Mon, 11 Dec 2023 20:31:30 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk

override_dh_auto_build:
	dh_auto_build -- CC='$(CC)' LD='$$(CC)' CFLAGS='$(CPPFLAGS) $(CFLAGS)' LDFLAGS='$(LDFLAGS)'

override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/xa65/usr

override_dh_auto_test:
	dh_auto_test --no-parallel

%:
	dh $@

=== debian/watch ===
# watch control file for uscan
version=4
https://www.floodgap.com/retrotech/xa/dists/xa-(.*)\.tar\.gz	debian	uupdate

## xa 2.4.1

=== misc/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 
 XCBMLIB = ..
 
-CFLAGS =  -Wall -O2 -ansi -W
+# -Wall -ansi et al. cause compile problems.
+CFLAGS =  -O2 -g
 
 LIBS = #-lncurses -ltermcap -lm

=== tests/adrm/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa 816.asm || exit 0 && exit 1
	../../xa zab.asm || exit 0 && exit 1
	../../xa zpa.asm || exit 0 && exit 1
	../../xa -C c02.asm || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa -C 02.asm -o 02.o
	../hextool -cmp=02.ok < 02.o
	../../xa c02.asm -o c02.o
	../hextool -cmp=c02.ok < c02.o
	../../xa -w 816.asm -o 816.o
	../hextool -cmp=816.ok < 816.o
	../../xa -w zab.asm -o zab.o
	../hextool -cmp=zab.ok < zab.o
	../../xa -w zpa.asm -o zpa.o
	../hextool -cmp=zpa.ok < zpa.o

clean:
	rm -f *.o

=== tests/align/Makefile ===

XA=../../xa

default: all
all: t01 t02 t03 t11 t12 t13 t21 t22 t23 t31 t32 t33 t41 t42 t43

# BSD only has suffix rules

.SUFFIXES: .o65 .hex .a65

#%.o65: %.s
.a65.o65:
	${XA} -R -c -o $@ $?

#%.hex: %.o65
.o65.hex:
	../hextool $? > $@

###############################################
# text segment correctly aligned

t01: t01.o65
	../hextool -cmp=$@.ok $@.o65

t02: t02.o65
	../hextool -cmp=$@.ok $@.o65

t03: t03.o65
	../hextool -cmp=$@.ok $@.o65

###############################################
# data segment correctly aligned

t11: t11.o65
	../hextool -cmp=$@.ok $@.o65

t12: t12.o65
	../hextool -cmp=$@.ok $@.o65

t13: t13.o65
	../hextool -cmp=$@.ok $@.o65

###############################################
# text segment incorrectly aligned

t21: t01.a65
	${XA} -R -c -bt 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t22: t02.a65
	${XA} -R -c -bt 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t23: t03.a65
	${XA} -R -c -bt 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

###############################################
# text segment correctly aligned, but data segment not (even if empty)

t31: t01.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t32: t02.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t33: t03.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

###############################################
# data segment incorrectly aligned

t41: t11.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t42: t12.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65

t43: t13.a65
	${XA} -R -c -bd 1025 -o $@.o65 $? 2> $@.msg
	../hextool -cmp=$@.mok $@.msg
	../hextool -cmp=$@.ok $@.o65


clean:
	rm -f *.o65 *.hex

=== tests/aserr/Makefile ===

default: test.s
	@echo expected to fail....
	../../xa -DBAD0 test.s || exit 0 && exit 1
	../../xa -DBAD1 test.s || exit 0 && exit 1
	../../xa -DBAD2 test.s || exit 0 && exit 1
	../../xa -DBAD3 test.s || exit 0 && exit 1
	../../xa -DBAD4 test.s || exit 0 && exit 1
	../../xa -DBAD5 test.s || exit 0 && exit 1
	@echo no more failures!
	../../xa test.s
	../hextool -cmp=ok < a.o65

clean:
	rm -f a.o65

=== tests/ca65/Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 CA65=ca65
 LD65=ld65
-OBJS=unnamed1 unnamed2 escape2
+OBJS=unnamed1 unnamed2 escape1 escape2 lll
 
 # escape1 test only relevant if xa23 mode is on
 #tests: unnamed1 unnamed2 escape1 escape2 clean
@@ -18,15 +18,23 @@
 	#${CA65} unnamed1.a65; ${LD65} -t none -o unnamed1.ca65 unnamed1.o; rm unnamed1.o
 	${XA} -XCA65 unnamed1.a65 -o $@
 	../hextool -cmp=unnamed1.ca65 < $@
+	${XA} -a unnamed1.a65 -o $@
+	../hextool -cmp=unnamed1.ca65 < $@
 
 unnamed2: unnamed2.a65
 	#${CA65} unnamed2.a65; ${LD65} -t none -o unnamed2.ca65 unnamed2.o; rm unnamed2.o
 	${XA} -XCA65 unnamed2.a65 -o $@ 2>a.err || true
 	../hextool -cmp=unnamed2.ca65 < $@
+	${XA} -a unnamed2.a65 -o $@ 2>a.err || true
+	../hextool -cmp=unnamed2.ca65 < $@
 
 # add -XXA23 to actually test this
 escape1: escape1.a65
-	${XA} escape1.a65 -o $@
+	# shouldn't work by default
+	${XA} escape1.a65 -o $@ || exit 0 && exit 1
+	${XA} -XXA23 escape1.a65 -o $@
+	../hextool -cmp=escape1.out < $@
+	${XA} -k escape1.a65 -o $@
 	../hextool -cmp=escape1.out < $@
 
 escape2: escape2.a65
@@ -34,6 +42,15 @@
 	${XA} -XCA65 escape2.a65 -o $@ 2>a.err || true
 	../hextool -cmp=escape2.ca65 < $@
 
+lll: lll.a65
+	# shouldn't work
+	${XA} lll.a65 -o $@ || exit 0 && exit 1
+	${XA} -a lll.a65 -o $@ || exit 0 && exit 1
+	${XA} -w lll.a65 -o $@ || exit 0 && exit 1
+	# should work
+	${XA} -XCA65 lll.a65 -o $@
+	../hextool -cmp=lll.out < $@
+
 clean:
 	rm -f *.err a.o65 $(OBJS)

=== tests/cll/Makefile ===

XA=../../xa

all: test1.o65

.SUFFIXES: .a65 .o65

.a65.o65:
	${XA} -XCA65 -o $@ $>

clean:
	rm -f *.o65
	rm -f test1

=== tests/comcom/Makefile ===
default:
	# this should fail.
	../../xa scomcom.asm || exit 0 && exit 1
	../../xa -a 816com.asm || exit 0 && exit 1
	../../xa -w 816com.asm || exit 0 && exit 1
	# it did fail. these should now all succeed.
	../../xa -XMASM scomcom.asm
	../hextool -cmp=scomcomm.ok < a.o65
	../../xa -a scomcom.asm
	../hextool -cmp=scomcomm.ok < a.o65
	../../xa comcom.asm
	../hextool -cmp=comcom.ok < a.o65
	../../xa -XMASM comcom.asm
	../hextool -cmp=comcomm.ok < a.o65
	../../xa -a comcom.asm
	../hextool -cmp=comcomm.ok < a.o65
	../../xa -a -w 816com.asm
	../hextool -cmp=816com.ok < a.o65

clean:
	rm -f a.o65

=== tests/cpktest/Makefile ===
default:
	../../xa -l test.l -o test.o pack_eng.a65
	../hextool -cmp=test.l < english.l || exit 1
	../hextool -cmp=eng.ok < test.o

	../../xa -l test.l -o test.o pack_ger.a65
	../hextool -cmp=test.l < deutsch.l || exit 1
	../hextool -cmp=de.ok < test.o
clean:
	rm -f *.o test.l

=== tests/ldoreloc/Makefile ===

default: all
all: t1 t2 t10 t11 t20 t21 t30 t31 t40 t41 t50 t51 t60 t61 t62

# BSD only has suffix rules

.SUFFIXES: .o65 .hex

#%.o65: %.s
.s.o65:
	../../xa -R -c -o $@ $<

#%.hex: %.o65
.o65.hex:
	../hextool $< > $@

linked.o65: 1.o65 2.o65
	../../ldo65 -o $@ 1.o65 2.o65

linked2.o65: 1.o65 2.o65
	../../ldo65 -o $@ 2.o65 1.o65

linked10.o65: 10.o65 2.o65
	../../ldo65 -U -o $@ 10.o65 2.o65

linked11.o65: 10.o65 2.o65
	../../ldo65 -U -o $@ 2.o65 10.o65

linked20.o65: 20.o65 2.o65
	../../ldo65 -Ll1 -o $@ 2.o65 20.o65

linked21.o65: 20.o65 2.o65
	../../ldo65 -L l1 -o $@ 20.o65 2.o65

linked22.o65: 20.o65 2.o65
	../../ldo65 -o $@ 20.o65 2.o65 && exit 1 || exit 0

linked30.o65: 30.o65 31.o65
	../../ldo65 -o $@ 30.o65 31.o65

linked31.o65: 30.o65 31.o65
	../../ldo65 -o $@ 31.o65 30.o65

linked40.o65: 40.o65 41.o65
	../../ldo65 -o $@ 40.o65 41.o65

linked41.o65: 40.o65 41.o65
	../../ldo65 -o $@ 41.o65 40.o65

linked50.o65: 50.o65 51.o65
	../../ldo65 -o $@ 50.o65 51.o65

linked51.o65: 50.o65 51.o65
	../../ldo65 -o $@ 51.o65 50.o65

linked60.o65: 60.o65 61.o65
	../../ldo65 -o $@ 60.o65 61.o65

linked61.o65: 60.o65 61.o65
	../../ldo65 -o $@ 61.o65 60.o65

linked62.o65: 60.o65 61.o65
	../../ldo65 -bd 65529 -bt 65523 -bz 255 -o $@ 61.o65 60.o65 && exit 1 || exit 0

# BSD make doesn't populate $< in these rules and GNU make doesn't like $>

t1: linked.o65
	../../reloc65 -bt 32768 -xt -o $@ linked.o65
	../hextool -cmp=$@ < t1.ok

t2: linked2.o65
	../../reloc65 -bt 32768 -xt -o $@ linked2.o65
	../hextool -cmp=$@ < t2.ok

t10: linked10.o65
	../../reloc65 -bt 32768 -xt -o $@ linked10.o65
	../hextool -cmp=$@ < t10.ok

t11: linked11.o65
	../../reloc65 -bt 32768 -xt -o $@ linked11.o65
	../hextool -cmp=$@ < t11.ok

t20: linked20.o65
	../../reloc65 -bt 32768 -xt -o $@ linked20.o65
	../hextool -cmp=$@ < t20.ok

t21: linked21.o65
	../../reloc65 -bt 32768 -xt -o $@ linked21.o65
	../hextool -cmp=$@ < t21.ok

t22: linked22.o65
	# should fail, so no action

t30: linked30.o65
	../../reloc65 -bt 32768 -xt -o $@ linked30.o65
	../hextool -cmp=$@ < t30.ok

t31: linked31.o65
	../../reloc65 -bt 32768 -xt -o $@ linked31.o65
	../hextool -cmp=$@ < t31.ok

t40: linked40.o65
	../../reloc65 -bt 32768 -xt -o $@ linked40.o65
	../hextool -cmp=$@ < t40.ok

t41: linked41.o65
	../../reloc65 -bt 32768 -xt -o $@ linked41.o65
	../hextool -cmp=$@ < t41.ok

t50: linked50.o65
	../../reloc65 -bt 32768 -bd 40960 -o $@ linked50.o65
	../hextool -cmp=$@ < t50.ok

t51: linked51.o65
	../../reloc65 -bt 32768 -bd 40960 -o $@ linked51.o65
	../hextool -cmp=$@ < t51.ok

t60: linked60.o65
	../../reloc65 -bt 32768 -bd 40960 -o $@ linked60.o65
	../hextool -cmp=$@ < t60.ok

t61: linked61.o65
	../../reloc65 -bt 32768 -bd 40960 -o $@ linked61.o65
	../hextool -cmp=$@ < t61.ok

t62: linked62.o65

clean:
	rm -f *.o65 *.hex t1 t2 t10 t11 t20 t21 t30 t31 t40 t41 t50 t51 t60 t61

=== tests/listing/Makefile ===
#
# Makefile for tests
#

XA=../../xa

CA65=ca65
LD65=ld65

tests: operatorsx.out assertx.out assertx.html linebreakx.out include1x.out listblocksx.html listca65x.html listca65_2x.html

operatorsx.out: operators.a65
	${XA} -P- -o operatorsx.o65 operators.a65 > $@
	../hextool -cmp=operators.out < $@

assertx.out: assert.a65
	${XA} -P- -o assertx.o65 assert.a65 > $@
	../hextool -cmp=assert.out < $@
	../hextool -cmp=assert.o65 < assertx.o65

assertx.html: assert.a65
	${XA} -P- -Fhtml -o assertx.o65 assert.a65 > $@
	../hextool -cmp=assert.html < $@

include1x.out: include1.a65
	${XA} -P- include1.a65 > $@
	../hextool -cmp=include1.out < $@

linebreakx.out: linebreak.a65
	${XA} -P- linebreak.a65 > $@
	../hextool -cmp=linebreak.out < $@

listblocksx.html: listblocks.a65
	${XA} -P- -Fhtml listblocks.a65 > $@
	../hextool -cmp=listblocks.html < $@

listca65x.html: listca65.a65
	${XA} -XCA65 -P- -Fhtml -o listca65x.o65 listca65.a65 > $@
	#${CA65} $>; ${LD65} -t none -o listca65.ca65 listca65.o; rm listca65.o
	../hextool -cmp=listca65.html < $@
	../hextool -cmp=listca65.ca65 < listca65x.o65

listca65_2x.html: listca65_2.a65
	${XA} -XCA65 -P- -Fhtml -o listca65_2x.o65 listca65_2.a65 > $@
	#${CA65} $>; ${LD65} -t none -o listca65_2.ca65 listca65_2.o; rm listca65_2.o
	../hextool -cmp=listca65_2.html < $@
	../hextool -cmp=listca65_2.ca65 < listca65_2x.o65

clean:
	rm -f *.err *x.out *x.html *x.o65

=== tests/masmcom/Makefile ===
default:
	# compile with masm mode on.
	../../xa -XMASM -o test.o test.s
	../hextool -cmp=okmasm < test.o
	# compile without
	../../xa -o test.o test.s
	../hextool -cmp=oknomasm < test.o

clean:
	rm -f *.o

=== tests/mvnmvp/Makefile ===
default:
	# xa should not allow this to happen. if it does, this test is no good.
	../../xa test.s || exit 0 && exit 1
	../../xa -w -DOLD_SYNTAX test.s || exit 0 && exit 1
	# expected-to-fail tests did fail. should be no more errors now.
	../../xa -w test.s -o test.o
	../hextool -cmp=ok < test.o

clean:
	rm -f *.o

=== debian/changelog ===
xa (2.4.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
  * Fix FTCBFS: Also pass cross tools to make install.
    Closes: #1063460. Thanks to Helmut Grohne for the patch!
  * Carets in string literals are now only special with -k, and documented
    in the man page. Closes: #861527.

 -- Stephen Kitt <skitt@debian.org>  Sat, 09 Mar 2024 16:32:05 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,10 @@
 Section: devel
 Priority: optional
 Maintainer: David Weinehall <tao@debian.org>
-Build-Depends: debhelper (>= 10)
+Build-Depends: debhelper-compat (= 13)
 Standards-Version: 4.1.1
-Homepage: http://www.floodgap.com/retrotech/xa/
+Homepage: https://www.floodgap.com/retrotech/xa/
+Rules-Requires-Root: no
 
 Package: xa65
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 	dh_auto_build -- CC='$(CC)' LD='$$(CC)' CFLAGS='$(CPPFLAGS) $(CFLAGS)' LDFLAGS='$(LDFLAGS)'
 
 override_dh_auto_install:
-	make install DESTDIR=$(CURDIR)/debian/xa65/usr
+	make install DESTDIR=$(CURDIR)/debian/xa65/usr CC='$(CC)' LD='$$(CC)' CFLAGS='$(CPPFLAGS) $(CFLAGS)' LDFLAGS='$(LDFLAGS)'
 
 override_dh_auto_test:
 	dh_auto_test --no-parallel
